//------------------------------------------------------------------------------
//
//  npdata.cpp
//  npe
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------


#include "npdata.h"
#include "data/npplot.h"
#include "io/npkey.h"

#include <stdlib.h>

void* gData;

void npInitDataMap(void* dataRef);
void npInitDataIO(void* dataRef);
void npInitDataCtrl(void* dataRef);


//------------------------------------------------------------------------------
void npInitDataMap(void* dataRef)
{
	pData data = (pData) dataRef;

	NPplotPtr plot = NULL;
	NPpointsPtr points = NULL;
	NPpinPtr pin = NULL;
	NPcameraPtr camera = NULL;
	NPvideoPtr video = NULL;
	NPgridPtr grid = NULL;

	npInitPlot (dataRef);

	data->map.plot[0] = npPlotNew (kPlotDefault, dataRef);	//global parent
	data->map.plot[1] = npPlotNew (kPlotCamera, dataRef);
	data->map.plot[2] = npPlotNew (kPlotGrid, dataRef);
	data->map.plot[3] = npPlotNew (kPlotPin, dataRef);
	data->map.plot[4] = npPlotNew (kPlotPoints, dataRef);
	data->map.plot[5] = npPlotNew (kPlotVideo, dataRef);
	
	data->map.plotCount = 6;
	data->map.plotIndex = 1;


	plot = data->map.plot[1];
	camera = (NPcameraPtr) plot->data;
	
	plot->translate.x = 0.0f;
	plot->translate.y = 4.0f;
	plot->translate.z = 5.0f;
	
	plot->rotate.angle = 0.0f;
	plot->rotate.x = 0.0f;					// change the rotate vs target.. zz debug
	plot->rotate.y = 0.0f;
	plot->rotate.z = -1.0f;

	camera->target.x = 0.0f;
	camera->target.y = 0.0f;
	camera->target.z = -0.1f;

}

//------------------------------------------------------------------------------
void npInitDataIO(void* dataRef)
{
	npInitKey (dataRef);
}

//------------------------------------------------------------------------------
void npInitDataCtrl(void* dataRef)
{
	
}

//------------------------------------------------------------------------------
void npInitData (int argc, char* argv[], void* dataRef)
{
	pData data = (pData) malloc (sizeof(Data));
	
	npInitDataMap (data);
	npInitDataIO (data);
	npInitDataCtrl (data);

	dataRef = gData = data;

	// create a fixed array of global data pointers that is thread safe,		ZZ
}


//------------------------------------------------------------------------------
void npCloseData()
{
	pData data = (pData) gData;
	
	free (data);
}

//------------------------------------------------------------------------------
void* npDataGetDataRef()
{
	return gData;
}


//------------------------------------------------------------------------------
void npDataUpdate (void* dataRef)
{

}